#include "dynamic_library_model.h"

#ifdef _WINDOWS
	#include <windows.h>
#endif

// Static initializations

const size_t Model::num_output_values = 0;

// The model instances.

Model* models;

// Model implementation

Model::Model()
{
	// Add any allocations and static calculations here.
	// Models will be allocated once at the beginning and then re-used for each likelihood evaluation.
}

Model::~Model()
{
	// Clean up any allocations here.
}

bool Model::EvaluateLikelihoodImpl(const double* values, double* llh)
{
	// Simulate model and evaluate likelihood

	// Store log likelihood in llh
	*llh = 0.0;

	return true;
}

bool Model::GetOutputImpl(double* output_values, size_t& numvalues)
{
	// Provide any output values from the simulation, these will be stored in the sampler output along with the variable values
	// This function is called after EvaluateLikelihoodImpl was called with the corresponding variable values
	// This function is also called once at the beginning, with a NULL output_values folder, to retrieve the number of output values you would like to store

	if (!output_values) {
		numvalues = num_output_values;
		return true;
	} else {
		// Fill output_values here
		return true;
	}
}


// DLL interface
#ifdef _WINDOWS
	#define EXPORT_PREFIX  extern "C" __declspec(dllexport)
#else
	#define EXPORT_PREFIX  extern "C"
#endif

EXPORT_PREFIX bool AllocateModels(size_t num_models)
{
	models = new Model[num_models];
	return (models != NULL);
}

EXPORT_PREFIX void DeallocateModels()
{
	delete [] models;
}

EXPORT_PREFIX bool EvaluateLikelihood(size_t model_i, const double* values, double* llh)
{
	return models[model_i].EvaluateLikelihoodImpl(values, llh);
}

EXPORT_PREFIX bool GetOutput(size_t model_i, double* output_values, size_t& numvalues)
{
	return models[model_i].GetOutputImpl(output_values, numvalues);
}
