#include "Utils.h"
#include "NestedSamplingStrategy.h"
#include "VariableSet.h"

namespace bcm {

NestedSamplingStrategy::NestedSamplingStrategy(SamplerNested* sampler)
	: sampler(sampler)
	, prior(sampler->prior)
	, sampling_population(sampler->sampling_population)
	, num_variables(sampler->varset->GetNumVariables())
	, population_size(sampler->population_size)
{
}

NestedSamplingStrategy::~NestedSamplingStrategy()
{
}

bool NestedSamplingStrategy::EvaluatePriorLikelihood(size_t threadix, const Real* values, Real& lprior, Real& llh) const
{
	return sampler->EvaluatePriorLikelihood(threadix, values, lprior, llh);
}

bool NestedSamplingStrategy::GetOutputValues(size_t threadix, Real* values) const
{
	return sampler->GetOutputValues(threadix, values);
}

}
