#pragma once

#include "SamplePopulation.h"
#include "SamplerNested.h"

namespace bcm {

class Sample;
class VariableSet;

class NestedSamplingStrategy
{
public:
	NestedSamplingStrategy(SamplerNested* sampler);
	virtual ~NestedSamplingStrategy();

	virtual bool Initialize(Real prior_volume_estimate, RNG* rng) { return true; }
	virtual bool UpdateRemoveSample(const Sample* removed_sample, Real prior_volume_estimate, bool& reset, RNG* rng) { return true; }
	virtual bool UpdateAddSample(const Sample* added_sample, RNG* rng) { return true; }
	virtual bool GetNewSample(Real min_llh, Sample* sample, RNG* rng, size_t threadix) const = 0;

protected:
	bool EvaluatePriorLikelihood(size_t threadix, const Real* values, Real& lprior, Real& llh) const;
	bool GetOutputValues(size_t threadix, Real* values) const;

	SamplerNested* sampler;
	const Prior* prior;
	size_t num_variables;
	size_t population_size;

	const SamplePopulation& sampling_population;
};

}
