#pragma once

#include "NestedSamplingStrategy.h"

namespace bcm {

class Prior;

class NestedSamplingStrategyEllipsoid : public NestedSamplingStrategy
{
public:
	NestedSamplingStrategyEllipsoid(SamplerNested* sampler);
	virtual ~NestedSamplingStrategyEllipsoid();
	
	virtual bool Initialize(Real prior_volume_estimate, RNG* rng);
	virtual bool UpdateRemoveSample(const Sample* removed_sample, Real prior_volume_estimate, bool& reset, RNG* rng);
	virtual bool UpdateAddSample(const Sample* added_sample, RNG* rng);
	virtual bool GetNewSample(Real min_llh, Sample* sample, RNG* rng, size_t threadix) const;

private:
	bool CalculateBounds();

	// Settings
	Real enlargement;
	size_t full_update_steps;

	// Run-time variables
	VectorReal mean;
	MatrixReal covariance;
	MatrixReal inv_covariance;
	MatrixReal transformation;
	Real scaling;
	
	size_t steps_since_update;
};

}
