#pragma once

#include "Prior.h"

namespace bcm {

class PriorGMM : public Prior
{
public:
	PriorGMM(VariableSet* varset);
	virtual ~PriorGMM();

	bool LoadFromXML(const boost::property_tree::ptree& xml_node);

	virtual bool EvaluateLogPDF(size_t threadix, const Real* values, Real& logp) const;
	virtual bool Sample(Real* values, RNG* rng) const;
	virtual bool EvaluateMarginalVariance(size_t i, Real& var) const;

protected:
	size_t num_components;
	VectorReal weights;
	std::vector<VectorReal> means;
	std::vector<MatrixReal> covariances;

	std::vector< Eigen::LLT<MatrixReal> > llt;
	VectorReal log_normalizing_constants;
	VectorReal log_weights;
};

}
