#pragma once

#include "Prior.h"

namespace bcm {

class PriorKDE : public Prior
{
public:
	PriorKDE(VariableSet* varset);
	virtual ~PriorKDE();

	bool LoadFromXML(const boost::property_tree::ptree& xml_node);

	virtual bool EvaluateLogPDF(size_t threadix, const Real* values, Real& logp) const;
	virtual bool Sample(Real* values, RNG* rng) const;
	virtual bool EvaluateMarginalVariance(size_t i, Real& var) const;

protected:
	size_t num_points;

	MatrixReal means;
	VectorReal bandwidths;
	VectorReal inv_bandwidths;
	Real log_normalizing_constant;
};

}
