#pragma once

#include "SMCSamplingStrategy.h"

namespace bcm {

class SMCSamplingStrategyKDE : public SMCSamplingStrategy
{
public:
	SMCSamplingStrategyKDE(SamplerSMC* sampler, TaskManager* task_manager);
	virtual ~SMCSamplingStrategyKDE();

protected:
	virtual bool UpdateStrategyIterationImpl(bool force_update, RNG* rng);
	virtual bool UpdateParticleImpl(SamplerSMC::Particle& particle, size_t ix, RNG* rng, size_t threadix);
	virtual bool CalculateParticleWeightImpl(SamplerSMC::Particle& particle, size_t ix, size_t threadix);

	enum EBandwidthMethod {
		BM_DiagonalSilverman,
	};

	// Settings
	EBandwidthMethod bandwidth_method;

	// Run-time variables
	// For diagonal-silverman
	VectorReal empirical_mean;
	VectorReal empirical_variance;
	VectorReal diagonal_bandwidth;
	VectorReal one_over_two_bw_sq;
	Real log_normalizing_constant;
};

}
