#pragma once

#include "RNG.h"
#include "Sampler.h"

namespace bcm {

class SamplerMH : public Sampler
{
public:
	SamplerMH(size_t num_threads);
	virtual ~SamplerMH();

	virtual size_t GetNumSamples() { return sampling_period; }

private:
	virtual bool ParseImpl(const boost::program_options::variables_map& vm);
	virtual bool InitializeImpl();
	virtual ERunResult RunImpl();

	// Settings
	size_t burnin_period;
	size_t sampling_period;
	size_t use_every_nth;
	Real proposal_scaling;
	
	// Run-time variables
	RNG* rng;
	VectorReal proposal_sigma;
	VectorReal current_var_values;
	VectorReal current_output_values;
	Real lprior;
	Real llh;
	Real lposterior;

	Real mode_lposterior;
	Real mode_llh;
	Real mode_lprior;
	VectorReal mode_values;
};

}
