#pragma once

#include "LikelihoodPart.h"

class LikelihoodTimeAverage : public LikelihoodPart
{
public:
	LikelihoodTimeAverage();
	virtual ~LikelihoodTimeAverage();

	virtual bool Load(const boost::property_tree::ptree& xml_node, const bcm::NetCDFDataFile* datafile);
	virtual bool SetVariableSet(const bcm::VariableSet* variables);
	virtual bool GetRequiredTimepoints(std::vector<Real>& timepoints);
	virtual bool EvaluateLogProbability(size_t threadix, const Real* values, SBMLModel* model, std::vector<Real> simulated_time, Real& logp);

private:
	size_t NumReplicates;
	Real StartTime;
	Real EndTime;
	std::vector<Real> Data;
};
