#pragma once

#include "Likelihood.h"
#include "OutputHandlerNetCDF.h"
#include "VariableSet.h"

class LikelihoodDataFile;
class SBMLModel;

class SBMLLikelihood : public bcm::Likelihood, public bcm::AdditionalOutputInterfaceNetCDF
{
public:
	SBMLLikelihood(size_t numthreads);
	~SBMLLikelihood();
	
	bool LoadFromXML(const std::string& filename);
	bool SetVariableSet(const bcm::VariableSet* varset);
	bool Initialize();
	bool SetupAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_count);
	void HandleAdditionalOutput(bcm::NetCDFDataFile* file, size_t sample_ix, const Real* values);

	virtual bool EvaluateLogProbability(size_t threadix, const Real* values, Real& logp);
	virtual bool GetOutput(size_t threadix, Real* output_values, size_t& numvalues);
	virtual void PostInference(const std::string& output_dir);

private:
	size_t numthreads;
	std::vector<LikelihoodDataFile*> DataFiles;
	SBMLModel* Model;
	bcm::OutputHandlerNetCDF* OutputHandler;
};
